qlserver 4.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152
  1. #!/bin/bash
  2. # Quake Live
  3. # Server Management Script
  4. # Author: Daniel Gibbs
  5. # Website: https://gameservermanagers.com
  6. if [ -f ".dev-debug" ]; then
  7. exec 5>dev-debug.log
  8. BASH_XTRACEFD="5"
  9. set -x
  10. fi
  11. version="060516"
  12. #### Variables ####
  13. # Notification Email
  14. # (on|off)
  15. emailnotification="off"
  16. email="email@example.com"
  17. # Steam login
  18. steamuser="anonymous"
  19. steampass=""
  20. # Start Variables
  21. arch="x64" # x64 or x86
  22. port="27960"
  23. rconport="28960"
  24. rconpassword="CHANGE_ME"
  25. statsport="${port}"
  26. statspassword="CHANGE_ME"
  27. mappool='mappool.txt'
  28. ip="0.0.0.0"
  29. updateonstart="off"
  30. # Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  31. # Console Commands : http://www.regurge.at/ql/
  32. fn_parms(){
  33. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${port} +set fs_homepath ${filesdir}/${port} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg}"
  34. }
  35. #### Advanced Variables ####
  36. # Github Branch Select
  37. # Allows for the use of different function files
  38. # from a different repo and/or branch.
  39. githubuser="dgibbs64"
  40. githubrepo="linuxgsm"
  41. githubbranch="master"
  42. # Steam
  43. appid="349090"
  44. # Server Details
  45. servicename="ql-server"
  46. gamename="Quake Live"
  47. engine="idtech3"
  48. # Directories
  49. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  50. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  51. lockselfname=".${servicename}.lock"
  52. lgsmdir="${rootdir}/lgsm"
  53. functionsdir="${lgsmdir}/functions"
  54. filesdir="${rootdir}/serverfiles"
  55. systemdir="${filesdir}"
  56. executabledir="${filesdir}"
  57. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  58. servercfg="${servicename}.cfg"
  59. servercfgdir="${filesdir}/baseq3"
  60. servercfgfullpath="${servercfgdir}/${servercfg}"
  61. servercfgdefault="${servercfgdir}/lgsm-default.cfg"
  62. backupdir="${rootdir}/backups"
  63. # Logging
  64. logdays="7"
  65. gamelogdir="${rootdir}/log/server"
  66. scriptlogdir="${rootdir}/log/script"
  67. consolelogdir="${rootdir}/log/console"
  68. consolelogging="on"
  69. gamelog="${gamelogdir}/${servicename}-game.log"
  70. scriptlog="${scriptlogdir}/${servicename}-script.log"
  71. consolelog="${consolelogdir}/${servicename}-console.log"
  72. emaillog="${scriptlogdir}/${servicename}-email.log"
  73. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%d-%m-%Y-%H-%M-%S').log"
  74. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%d-%m-%Y-%H-%M-%S').log"
  75. ##### Script #####
  76. # Do not edit
  77. # Fetches core_dl for file downloads
  78. fn_fetch_core_dl(){
  79. github_file_url_dir="lgsm/functions"
  80. github_file_url_name="${functionfile}"
  81. filedir="${functionsdir}"
  82. filename="${github_file_url_name}"
  83. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  84. # If the file is missing, then download
  85. if [ ! -f "${filedir}/${filename}" ]; then
  86. if [ ! -d "${filedir}" ]; then
  87. mkdir -p "${filedir}"
  88. fi
  89. echo -e " fetching ${filename}...\c"
  90. # Check curl exists and use available path
  91. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  92. for curlcmd in ${curlpaths}
  93. do
  94. if [ -x "${curlcmd}" ]; then
  95. break
  96. fi
  97. done
  98. # If curl exists download file
  99. if [ "$(basename ${curlcmd})" == "curl" ]; then
  100. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  101. if [ $? -ne 0 ]; then
  102. echo -e "\e[0;31mFAIL\e[0m\n"
  103. echo "${curlfetch}"
  104. echo -e "${githuburl}\n"
  105. exit 1
  106. else
  107. echo -e "\e[0;32mOK\e[0m"
  108. fi
  109. else
  110. echo -e "\e[0;31mFAIL\e[0m\n"
  111. echo "Curl is not installed!"
  112. echo -e ""
  113. exit 1
  114. fi
  115. chmod +x "${filedir}/${filename}"
  116. fi
  117. source "${filedir}/${filename}"
  118. }
  119. core_dl.sh(){
  120. # Functions are defined in core_functions.sh.
  121. functionfile="${FUNCNAME}"
  122. fn_fetch_core_dl
  123. }
  124. core_functions.sh(){
  125. # Functions are defined in core_functions.sh.
  126. functionfile="${FUNCNAME}"
  127. fn_fetch_core_dl
  128. }
  129. core_dl.sh
  130. core_functions.sh
  131. getopt=$1
  132. core_getopt.sh